Index: trunk/FACT++/src/EventBuilder.c
===================================================================
--- trunk/FACT++/src/EventBuilder.c	(revision 11763)
+++ trunk/FACT++/src/EventBuilder.c	(revision 11766)
@@ -13,5 +13,5 @@
 #include <errno.h>
 #include <unistd.h>
-#include <sys/types.h> 
+#include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
@@ -24,74 +24,79 @@
 enum Severity
 {
-        kMessage = 10, ///< Just a message, usually obsolete
-        kInfo    = 20, ///< An info telling something which can be interesting to know
-        kWarn    = 30, ///< A warning, things that somehow might result in unexpected or unwanted bahaviour
-        kError   = 40, ///< Error, something unexpected happened, but can still be handled by the program
-        kFatal   = 50, ///< An error which cannot be handled at all happend, the only solution is program termination
-        kDebug   = 99, ///< A message used for debugging only
+   kMessage = 10,               ///< Just a message, usually obsolete
+   kInfo = 20,                  ///< An info telling something which can be interesting to know
+   kWarn = 30,                  ///< A warning, things that somehow might result in unexpected or unwanted bahaviour
+   kError = 40,                 ///< Error, something unexpected happened, but can still be handled by the program
+   kFatal = 50,                 ///< An error which cannot be handled at all happend, the only solution is program termination
+   kDebug = 99,                 ///< A message used for debugging only
 };
 
-#define MIN_LEN  32        // min #bytes needed to interpret FADheader
-#define MAX_LEN 256*1024   // size of read-buffer per socket
+#define MIN_LEN  32             // min #bytes needed to interpret FADheader
+#define MAX_LEN 256*1024        // size of read-buffer per socket
 
 //#define nanosleep(x,y)
 
-extern FileHandle_t  runOpen(uint32_t irun, RUN_HEAD *runhd, size_t len ) ;
-extern int  runWrite(FileHandle_t fileHd ,  EVENT    *event, size_t len ) ;
-extern int  runClose(FileHandle_t fileHd ,  RUN_TAIL *runth, size_t len ) ;
-extern void factOut(int severity, int err, char* message ) ;
-extern void gotNewRun( int runnr, PEVNT_HEADER *headers ); 
-
-
-extern void factStat(GUI_STAT gj) ;
-
-extern void factStatNew(EVT_STAT gi) ;
-
-extern int  eventCheck( uint32_t runNr, PEVNT_HEADER *fadhd, EVENT *event) ;
-
-extern int subProcEvt(int threadID, PEVNT_HEADER *fadhd, EVENT *event, int8_t *buffer) ;
-
-extern void debugHead(int i, int j, void *buf); 
-
-extern void debugRead(int isock, int ibyte, int32_t event,int32_t ftmevt, 
-                      int32_t runnr, int state, uint32_t tsec, uint32_t tusec ) ;
-extern void debugStream(int isock, void *buf, int len) ;
-
-int CloseRunFile(uint32_t runId, uint32_t closeTime, uint32_t maxEvt);
-
-
-int g_maxProc   ;
-int g_maxSize   ;
-int gi_maxSize  ;
-int gi_maxProc  ;
-
-uint g_actTime   ;
-uint g_actUsec   ;
-int  g_runStat   ;
-int  g_reset     ;
-int  g_useFTM    ;
-
-int gi_reset, gi_resetR, gi_resetS, gi_resetW, gi_resetX ;
-size_t g_maxMem  ;  //maximum memory allowed for buffer
+extern FileHandle_t runOpen (uint32_t irun, RUN_HEAD * runhd, size_t len);
+extern int runWrite (FileHandle_t fileHd, EVENT * event, size_t len);
+extern int runClose (FileHandle_t fileHd, RUN_TAIL * runth, size_t len);
+//extern int runFinish (uint32_t runnr);
+
+extern void factOut (int severity, int err, char *message);
+
+extern void gotNewRun (int runnr, PEVNT_HEADER * headers);
+
+
+extern void factStat (GUI_STAT gj);
+
+extern void factStatNew (EVT_STAT gi);
+
+extern int eventCheck (uint32_t runNr, PEVNT_HEADER * fadhd, EVENT * event);
+
+extern int subProcEvt (int threadID, PEVNT_HEADER * fadhd, EVENT * event,
+                       int8_t * buffer);
+
+extern void debugHead (int i, int j, void *buf);
+
+extern void debugRead (int isock, int ibyte, int32_t event, int32_t ftmevt,
+                       int32_t runnr, int state, uint32_t tsec,
+                       uint32_t tusec);
+extern void debugStream (int isock, void *buf, int len);
+
+int CloseRunFile (uint32_t runId, uint32_t closeTime, uint32_t maxEvt);
+
+
+int g_maxProc;
+int g_maxSize;
+int gi_maxSize;
+int gi_maxProc;
+
+uint g_actTime;
+uint g_actUsec;
+int g_runStat;
+int g_reset;
+int g_useFTM;
+
+int gi_reset, gi_resetR, gi_resetS, gi_resetW, gi_resetX;
+size_t g_maxMem;                //maximum memory allowed for buffer
 
 //no longer needed ...
-    int     g_maxBoards ;    //maximum number of boards to be initialized
-    int     g_actBoards  ;
+int g_maxBoards;                //maximum number of boards to be initialized
+int g_actBoards;
 //
 
-FACT_SOCK g_port[NBOARDS] ;  // .addr=string of IP-addr in dotted-decimal "ddd.ddd.ddd.ddd"
-
-
- int gi_runStat ;
- int gp_runStat ;
- int gw_runStat ;
-
- int gi_memStat = +1 ;
-
- uint32_t gi_myRun = 0 ;
- uint32_t actrun   =       0 ;
-
-
-uint gi_NumConnect[NBOARDS];   //4 crates * 10 boards
+FACT_SOCK g_port[NBOARDS];      // .addr=string of IP-addr in dotted-decimal "ddd.ddd.ddd.ddd"
+
+
+int gi_runStat;
+int gp_runStat;
+int gw_runStat;
+
+int gi_memStat = +1;
+
+uint32_t gi_myRun = 0;
+uint32_t actrun = 0;
+
+
+uint gi_NumConnect[NBOARDS];    //4 crates * 10 boards
 
 //uint gi_EvtStart= 0 ;
@@ -104,22 +109,22 @@
 //uint gp_EvtTot  = 0 ;
 
-PIX_MAP g_pixMap[NPIX] ;
-
-EVT_STAT    gi ;
-GUI_STAT    gj ;
-
-EVT_CTRL    evtCtrl ;       //control of events during processing
-int         evtIdx[MAX_EVT*MAX_RUN] ; //index from mBuffer to evtCtrl
-
-WRK_DATA    mBuffer[MAX_EVT*MAX_RUN]; //local working space
-
-
-
-
-RUN_HEAD    actRun ;
-
-RUN_CTRL    runCtrl[MAX_RUN] ;
-
-RUN_TAIL    runTail[MAX_RUN] ;
+PIX_MAP g_pixMap[NPIX];
+
+EVT_STAT gi;
+GUI_STAT gj;
+
+EVT_CTRL evtCtrl;               //control of events during processing
+int evtIdx[MAX_EVT * MAX_RUN];  //index from mBuffer to evtCtrl
+
+WRK_DATA mBuffer[MAX_EVT * MAX_RUN];    //local working space
+
+
+
+
+RUN_HEAD actRun;
+
+RUN_CTRL runCtrl[MAX_RUN];
+
+RUN_TAIL runTail[MAX_RUN];
 
 
@@ -129,54 +134,57 @@
 
 
-typedef union {
-  int8_t  B[MAX_LEN  ];
-  int16_t S[MAX_LEN/2];
-  int32_t I[MAX_LEN/4];
-  int64_t L[MAX_LEN/8];
-} CNV_FACT ;
-
-typedef struct {
-  int  bufTyp ;          //what are we reading at the moment: 0=header 1=data -1=skip ...
-  int32_t  bufPos ;          //next byte to read to the buffer next
-  int32_t  bufLen ;          //number of bytes left to read
-  int32_t  skip ;            //number of bytes skipped before start of event
-
-  int  sockStat   ;      //-1 if socket not yet connected  , 99 if not exist
-  int  socket     ;      //contains the sockets
-  struct sockaddr_in SockAddr ; //IP for each socket
-
-  int  evtID  ;          // event ID of event currently read
-  int  runID  ;          // run       "
-  int  ftmID  ;          // event ID from FTM
-  uint fadLen ;          // FADlength of event currently read
-  int  fadVers ;         // Version of FAD
-  int  ftmTyp ;          // trigger type
-  int  board ;           // boardID (softwareID: 0..40 )
-  int  Port ;
-
-  CNV_FACT *rBuf ;
+typedef union
+{
+   int8_t B[MAX_LEN];
+   int16_t S[MAX_LEN / 2];
+   int32_t I[MAX_LEN / 4];
+   int64_t L[MAX_LEN / 8];
+} CNV_FACT;
+
+typedef struct
+{
+   int bufTyp;                  //what are we reading at the moment: 0=header 1=data -1=skip ...
+   int32_t bufPos;              //next byte to read to the buffer next
+   int32_t bufLen;              //number of bytes left to read
+   int32_t skip;                //number of bytes skipped before start of event
+
+   int sockStat;                //-1 if socket not yet connected  , 99 if not exist
+   int socket;                  //contains the sockets
+   struct sockaddr_in SockAddr; //IP for each socket
+
+   int evtID;                   // event ID of event currently read
+   int runID;                   // run       "
+   int ftmID;                   // event ID from FTM
+   uint fadLen;                 // FADlength of event currently read
+   int fadVers;                 // Version of FAD
+   int ftmTyp;                  // trigger type
+   int board;                   // boardID (softwareID: 0..40 )
+   int Port;
+
+   CNV_FACT *rBuf;
 
 #ifdef EVTDEBUG
-  CNV_FACT *xBuf ;      //a copy of rBuf (temporary for debuging) 
+   CNV_FACT *xBuf;              //a copy of rBuf (temporary for debuging) 
 #endif
 
-} READ_STRUCT ;
-
-
-typedef union {
-  int8_t  B[2];
-  int16_t S  ;
-} SHORT_BYTE ;
-
-
-
-
-
-#define MXSTR 1000 
-char str[MXSTR] ;
-
-SHORT_BYTE  start, stop;
-
-READ_STRUCT rd[MAX_SOCK] ;  //buffer to read IP and afterwards store in mBuffer
+} READ_STRUCT;
+
+
+typedef union
+{
+   int8_t B[2];
+   int16_t S;
+} SHORT_BYTE;
+
+
+
+
+
+#define MXSTR 1000
+char str[MXSTR];
+
+SHORT_BYTE start, stop;
+
+READ_STRUCT rd[MAX_SOCK];       //buffer to read IP and afterwards store in mBuffer
 
 
@@ -187,7 +195,18 @@
 /*-----------------------------------------------------------------*/
 
-
-
-int GenSock(int flag, int sid,  int port, struct sockaddr_in *sockAddr,  READ_STRUCT *rd) {
+int
+runFinish1 (uint32_t runnr)
+{
+   snprintf (str, MXSTR, "Should finish run %d (but not yet possible)",
+             runnr);
+   factOut (kInfo, 173, str);   //but continue anyhow
+   return 0;
+}
+
+
+int
+GenSock (int flag, int sid, int port, struct sockaddr_in *sockAddr,
+         READ_STRUCT * rd)
+{
 /*
 *** generate Address, create sockets and allocates readbuffer for it
@@ -200,83 +219,83 @@
  */
 
-  int j ;
-  int optval = 1 ;                       //activate keepalive
-  socklen_t optlen = sizeof(optval);
-
-  if (rd->sockStat ==0 ) {   //close socket if open
-     j=close(rd->socket) ;
-     if (j>0) {
-        snprintf(str,MXSTR,"Error closing socket %d | %m",sid);
-        factOut(kFatal,771, str ) ;
-     } else {
-        snprintf(str,MXSTR,"Succesfully closed socket %d",sid);
-        factOut(kInfo,771, str ) ;
-     }
-  }
-
-
-  if (flag < 0) {
-     free(rd->rBuf) ;   //and never open again
+   int j;
+   int optval = 1;              //activate keepalive
+   socklen_t optlen = sizeof (optval);
+
+   if (rd->sockStat == 0) {     //close socket if open
+      j = close (rd->socket);
+      if (j > 0) {
+         snprintf (str, MXSTR, "Error closing socket %d | %m", sid);
+         factOut (kFatal, 771, str);
+      } else {
+         snprintf (str, MXSTR, "Succesfully closed socket %d", sid);
+         factOut (kInfo, 771, str);
+      }
+   }
+
+
+   if (flag < 0) {
+      free (rd->rBuf);          //and never open again
 #ifdef EVTDEBUG
-     free(rd->xBuf) ;   //and never open again
+      free (rd->xBuf);          //and never open again
 #endif
-     rd->rBuf = NULL ;     
-     rd->sockStat = 99 ;  
-     return 0 ;
-  }
-
-
-  if (flag == 0) {    //generate address and buffer ...
-     rd->Port  = port ;
-     rd->SockAddr.sin_family = sockAddr->sin_family;
-     rd->SockAddr.sin_port = htons(port) ;
-     rd->SockAddr.sin_addr = sockAddr->sin_addr ;
+      rd->rBuf = NULL;
+      rd->sockStat = 99;
+      return 0;
+   }
+
+
+   if (flag == 0) {             //generate address and buffer ...
+      rd->Port = port;
+      rd->SockAddr.sin_family = sockAddr->sin_family;
+      rd->SockAddr.sin_port = htons (port);
+      rd->SockAddr.sin_addr = sockAddr->sin_addr;
 
 #ifdef EVTDEBUG
-     rd->xBuf = malloc(sizeof(CNV_FACT) ) ;
+      rd->xBuf = malloc (sizeof (CNV_FACT));
 #endif
-     rd->rBuf = malloc(sizeof(CNV_FACT) ) ;
-     if ( rd->rBuf == NULL ) {
-        snprintf(str,MXSTR,"Could not create local buffer %d",sid);
-        factOut(kFatal,774, str ) ;
-        rd->sockStat = 77 ;
-        return -3 ;
-     }
-  }
-
-
-  if ( (rd->socket = socket (PF_INET, SOCK_STREAM | SOCK_NONBLOCK, 0)) <= 0) {
-     snprintf(str,MXSTR,"Could not generate socket %d | %m",sid);
-     factOut(kFatal,773, str ) ;
-     rd->sockStat = 88 ;
-     return -2 ;
-  }
-  optval=1;
-  if ( setsockopt(rd->socket, SOL_SOCKET, SO_KEEPALIVE, &optval, optlen) < 0) {
-     snprintf(str,MXSTR,"Could not set keepalive %d | %m",sid);
-     factOut(kInfo,173, str ) ;  //but continue anyhow
-  }
-  optval=10; //start after 10 seconds
-  if ( setsockopt(rd->socket, SOL_TCP, TCP_KEEPIDLE, &optval, optlen) < 0) {
-     snprintf(str,MXSTR,"Could not set keepidle %d | %m",sid);
-     factOut(kInfo,173, str ) ;  //but continue anyhow
-  }
-  optval=10; //do every 10 seconds
-  if ( setsockopt(rd->socket, SOL_TCP, TCP_KEEPINTVL, &optval, optlen) < 0) {
-     snprintf(str,MXSTR,"Could not set keepintvl %d | %m",sid);
-     factOut(kInfo,173, str ) ;  //but continue anyhow
-  }
-  optval=2;  //close after 2 unsuccessful tries
-  if ( setsockopt(rd->socket, SOL_TCP, TCP_KEEPCNT, &optval, optlen) < 0) {
-     snprintf(str,MXSTR,"Could not set keepalive probes %d | %m",sid);
-     factOut(kInfo,173, str ) ;  //but continue anyhow
-  }
-
-
-
-  snprintf(str,MXSTR,"Successfully generated socket %d ",sid);
-  factOut(kInfo,773, str ) ;
-  rd->sockStat = -1 ;    //try to (re)open socket
-  return 0 ;
+      rd->rBuf = malloc (sizeof (CNV_FACT));
+      if (rd->rBuf == NULL) {
+         snprintf (str, MXSTR, "Could not create local buffer %d", sid);
+         factOut (kFatal, 774, str);
+         rd->sockStat = 77;
+         return -3;
+      }
+   }
+
+
+   if ((rd->socket = socket (PF_INET, SOCK_STREAM | SOCK_NONBLOCK, 0)) <= 0) {
+      snprintf (str, MXSTR, "Could not generate socket %d | %m", sid);
+      factOut (kFatal, 773, str);
+      rd->sockStat = 88;
+      return -2;
+   }
+   optval = 1;
+   if (setsockopt (rd->socket, SOL_SOCKET, SO_KEEPALIVE, &optval, optlen) < 0) {
+      snprintf (str, MXSTR, "Could not set keepalive %d | %m", sid);
+      factOut (kInfo, 173, str);        //but continue anyhow
+   }
+   optval = 10;                 //start after 10 seconds
+   if (setsockopt (rd->socket, SOL_TCP, TCP_KEEPIDLE, &optval, optlen) < 0) {
+      snprintf (str, MXSTR, "Could not set keepidle %d | %m", sid);
+      factOut (kInfo, 173, str);        //but continue anyhow
+   }
+   optval = 10;                 //do every 10 seconds
+   if (setsockopt (rd->socket, SOL_TCP, TCP_KEEPINTVL, &optval, optlen) < 0) {
+      snprintf (str, MXSTR, "Could not set keepintvl %d | %m", sid);
+      factOut (kInfo, 173, str);        //but continue anyhow
+   }
+   optval = 2;                  //close after 2 unsuccessful tries
+   if (setsockopt (rd->socket, SOL_TCP, TCP_KEEPCNT, &optval, optlen) < 0) {
+      snprintf (str, MXSTR, "Could not set keepalive probes %d | %m", sid);
+      factOut (kInfo, 173, str);        //but continue anyhow
+   }
+
+
+
+   snprintf (str, MXSTR, "Successfully generated socket %d ", sid);
+   factOut (kInfo, 773, str);
+   rd->sockStat = -1;           //try to (re)open socket
+   return 0;
 
 } /*-----------------------------------------------------------------*/
@@ -287,28 +306,30 @@
 
 
-int mBufInit() {
+int
+mBufInit ()
+{
 // initialize mBuffer (mark all entries as unused\empty)
 
-   int i ;
-   uint32_t actime ;
-
-   actime = g_actTime + 50000000 ;
-
-   for (i=0; i<MAX_EVT*MAX_RUN; i++) {
+   int i;
+   uint32_t actime;
+
+   actime = g_actTime + 50000000;
+
+   for (i = 0; i < MAX_EVT * MAX_RUN; i++) {
       mBuffer[i].evNum = mBuffer[i].nRoi = -1;
-      mBuffer[i].runNum= 0 ;
-
-      evtCtrl.evtBuf[  i] = -1 ;
-      evtCtrl.evtStat[ i] = -1 ;
-      evtCtrl.pcTime[  i] = actime ;  //initiate to far future
-   }
-
-
-   actRun.FADhead = malloc( NBOARDS* sizeof(PEVNT_HEADER) ) ;
-
-   evtCtrl.frstPtr = 0 ;
-   evtCtrl.lastPtr = 0 ;
-
-   return 0 ;
+      mBuffer[i].runNum = 0;
+
+      evtCtrl.evtBuf[i] = -1;
+      evtCtrl.evtStat[i] = -1;
+      evtCtrl.pcTime[i] = actime;       //initiate to far future
+   }
+
+
+   actRun.FADhead = malloc (NBOARDS * sizeof (PEVNT_HEADER));
+
+   evtCtrl.frstPtr = 0;
+   evtCtrl.lastPtr = 0;
+
+   return 0;
 
 } /*-----------------------------------------------------------------*/
@@ -317,6 +338,8 @@
 
 
-int mBufEvt( int evID, uint runID, int nRoi[], int sk, 
-             int fadlen, int trgTyp, int trgNum, int fadNum) {
+int
+mBufEvt (int evID, uint runID, int nRoi[], int sk,
+         int fadlen, int trgTyp, int trgNum, int fadNum)
+{
 // generate a new Event into mBuffer:   
 // make sure only complete Event are possible, so 'free' will always work
@@ -327,235 +350,257 @@
 //        < 0    if no space left
 
-   struct timeval  *tv, atv;
-   tv=&atv;
-   uint32_t tsec, tusec ;
-
-   int i, k, jr, b, evFree ;
-   int headmem=0 ;
-   size_t needmem = 0 ;
-
-
-   b = sk/7 ;
-
-   if (nRoi[0] <0 || nRoi[0] > 1024) {
-      snprintf(str,MXSTR,"illegal nRoi[0]: %d",nRoi[0]) ;
-      factOut(kError, 999, str ) ;
-      gj.badRoiR++ ;
-      gj.badRoi[b]++ ;
-      return -9999 ;
-   }
-
-   for (jr=1; jr<8; jr++) {
-      if ( nRoi[jr] != nRoi[0] ) {
-         snprintf(str,MXSTR,"wrong nRoi[%d]: %d %d",jr,nRoi[jr],nRoi[0]) ;
-         factOut(kError,711, str ) ;
-         gj.badRoiB++ ;
-         gj.badRoi[b]++ ;
-         return -7101 ;
-      }
-   }
-   if ( nRoi[8] < nRoi[0] ) {
-         snprintf(str,MXSTR,"wrong nRoi_TM: %d %d",nRoi[8],nRoi[0]) ;
-         factOut(kError,712, str ) ;
-         gj.badRoiB++ ;
-         gj.badRoi[b]++ ;
-         return -7102 ;
-   }
-
-
-   i = evID % MAX_EVT ;
-   evFree = -1 ;
-
-   for ( k=0; k<MAX_RUN; k++) {
-      if ( mBuffer[i].evNum == evID
-        && mBuffer[i].runNum== runID ) {   //event is already registered;
-                                           // is it ok ????
-         if ( mBuffer[i].nRoi   != nRoi[0] 
-           || mBuffer[i].nRoiTM != nRoi[8] ) {
-            snprintf(str,MXSTR,"illegal evt_roi %d %d ; %d %d",
-              nRoi[0],nRoi[8], mBuffer[i].nRoi, mBuffer[i].nRoiTM );
-            factOut(kError,821, str ) ;
-            gj.badRoiE++ ;
-            gj.badRoi[b]++ ;
-            return -8201 ;
+   struct timeval *tv, atv;
+   tv = &atv;
+   uint32_t tsec, tusec;
+   uint oldest;
+   int jold;
+
+   int i, k, jr, b, evFree;
+   int headmem = 0;
+   size_t needmem = 0;
+
+
+   b = sk / 7;
+
+   if (nRoi[0] < 0 || nRoi[0] > 1024) {
+      snprintf (str, MXSTR, "illegal nRoi[0]: %d", nRoi[0]);
+      factOut (kError, 999, str);
+      gj.badRoiR++;
+      gj.badRoi[b]++;
+      return -9999;
+   }
+
+   for (jr = 1; jr < 8; jr++) {
+      if (nRoi[jr] != nRoi[0]) {
+         snprintf (str, MXSTR, "wrong nRoi[%d]: %d %d", jr, nRoi[jr],
+                   nRoi[0]);
+         factOut (kError, 711, str);
+         gj.badRoiB++;
+         gj.badRoi[b]++;
+         return -7101;
+      }
+   }
+   if (nRoi[8] < nRoi[0]) {
+      snprintf (str, MXSTR, "wrong nRoi_TM: %d %d", nRoi[8], nRoi[0]);
+      factOut (kError, 712, str);
+      gj.badRoiB++;
+      gj.badRoi[b]++;
+      return -7102;
+   }
+
+
+   i = evID % MAX_EVT;
+   evFree = -1;
+
+   for (k = 0; k < MAX_RUN; k++) {
+      if (mBuffer[i].evNum == evID && mBuffer[i].runNum == runID) {     //event is already registered;
+         // is it ok ????
+         if (mBuffer[i].nRoi != nRoi[0]
+             || mBuffer[i].nRoiTM != nRoi[8]) {
+            snprintf (str, MXSTR, "illegal evt_roi %d %d ; %d %d",
+                      nRoi[0], nRoi[8], mBuffer[i].nRoi, mBuffer[i].nRoiTM);
+            factOut (kError, 821, str);
+            gj.badRoiE++;
+            gj.badRoi[b]++;
+            return -8201;
          }
-
 //       count for inconsistencies
 
-         if ( mBuffer[i].trgNum != trgNum ) mBuffer[i].Errors[0]++ ;
-         if ( mBuffer[i].fadNum != fadNum ) mBuffer[i].Errors[1]++ ;
-         if ( mBuffer[i].trgTyp != trgTyp ) mBuffer[i].Errors[2]++ ;
+         if (mBuffer[i].trgNum != trgNum)
+            mBuffer[i].Errors[0]++;
+         if (mBuffer[i].fadNum != fadNum)
+            mBuffer[i].Errors[1]++;
+         if (mBuffer[i].trgTyp != trgTyp)
+            mBuffer[i].Errors[2]++;
 
          //everything seems fine so far ==> use this slot ....
-         return i ;  
-      }
-      if ( evFree < 0 && mBuffer[i].evNum < 0 ) evFree = i ;
-      i += MAX_EVT ;
+         return i;
+      }
+      if (evFree < 0 && mBuffer[i].evNum < 0)
+         evFree = i;
+      i += MAX_EVT;
    }
 
 
    //event does not yet exist; create it
-   if (evFree < 0 ) {        //no space available in ctrl
-        snprintf(str,MXSTR,"no control slot to keep event %d",evID) ;
-        factOut(kError,881, str ) ;
-        return -1 ;
-   }
-   i = evFree ;   //found free entry; use it ...
-
-   gettimeofday( tv, NULL);
-   tsec = atv.tv_sec ;
-   tusec= atv.tv_usec ; 
+   if (evFree < 0) {            //no space available in ctrl
+      snprintf (str, MXSTR, "no control slot to keep event %d", evID);
+      factOut (kError, 881, str);
+      return -1;
+   }
+   i = evFree;                  //found free entry; use it ...
+
+   gettimeofday (tv, NULL);
+   tsec = atv.tv_sec;
+   tusec = atv.tv_usec;
 
    //check if runId already registered in runCtrl
-   evFree = -1 ;
-   for (k=0; k<MAX_RUN; k++) {
-      if (runCtrl[k].runId == runID ) {
-         if ( runCtrl[k].roi0 != nRoi[0]
-           || runCtrl[k].roi8 != nRoi[8] ) {
-            snprintf(str,MXSTR,"illegal run_roi %d %d ; %d %d",
-               nRoi[0],nRoi[8],runCtrl[k].roi0,runCtrl[k].roi8 );
-            factOut(kError,931, str ) ;
-            gj.badRoiR++ ;
-            gj.badRoi[b]++ ;
-            return -9301 ;
+   evFree = -1;
+   oldest = g_actTime + 1000;
+   jold = -1;
+   for (k = 0; k < MAX_RUN; k++) {
+      if (runCtrl[k].runId == runID) {
+         if (runCtrl[k].procId > 0) {   //run is closed -> reject
+            snprintf (str, MXSTR, "skip event since run %d finished", runID);
+            factOut (kInfo, 931, str);
+            return -21;
          }
-         goto RUNFOUND ;
-      }
-      else if (evFree < 0 && runCtrl[k].runId == 0 ) evFree = k ;
-   }
-   
-   if (evFree <0 ) {
-      snprintf(str,MXSTR,"not able to register the new run %d",runID);
-      factOut(kFatal,883, str ) ;
-      return -1001 ;
+
+         if (runCtrl[k].roi0 != nRoi[0]
+             || runCtrl[k].roi8 != nRoi[8]) {
+            snprintf (str, MXSTR, "illegal run_roi %d %d ; %d %d",
+                      nRoi[0], nRoi[8], runCtrl[k].roi0, runCtrl[k].roi8);
+            factOut (kError, 931, str);
+            gj.badRoiR++;
+            gj.badRoi[b]++;
+            return -9301;
+         }
+         goto RUNFOUND;
+      } else if (evFree < 0 && runCtrl[k].fileId < 0) { //not yet used
+         evFree = k;
+      } else if (evFree < 0 && runCtrl[k].fileId > 0) { //already closed
+         if (runCtrl[k].closeTime < oldest) {
+            oldest = runCtrl[k].closeTime;
+            jold = k;
+         }
+      }
+   }
+
+   if (evFree < 0 && jold < 0) {
+      snprintf (str, MXSTR, "not able to register the new run %d", runID);
+      factOut (kFatal, 883, str);
+      return -1001;
    } else {
-      snprintf(str,MXSTR,"register new run %d roi: %d %d",runID,nRoi[0],nRoi[8]) ;
-      factOut(kInfo,503, str ) ;
-      runCtrl[evFree].runId = runID ;
-      runCtrl[evFree].roi0  = nRoi[0] ;
-      runCtrl[evFree].roi8  = nRoi[8] ;
-      runCtrl[evFree].fileId = -2 ;
-      runCtrl[evFree].lastEvt= -1 ;
-      runCtrl[evFree].nextEvt= 0;
+      if (evFree < 0)
+         evFree = jold;
+      snprintf (str, MXSTR, "register new run %d(%d) roi: %d %d", runID,
+                evFree, nRoi[0], nRoi[8]);
+      factOut (kInfo, 503, str);
+      runCtrl[evFree].runId = runID;
+      runCtrl[evFree].roi0 = nRoi[0];
+      runCtrl[evFree].roi8 = nRoi[8];
+      runCtrl[evFree].fileId = -2;
+      runCtrl[evFree].procId = -2;
+      runCtrl[evFree].lastEvt = -1;
+      runCtrl[evFree].nextEvt = 0;
       runCtrl[evFree].actEvt = 0;
-      runCtrl[evFree].maxEvt = 999999999 ; //max number events allowed
-      runCtrl[evFree].firstUsec=tusec ;
-      runCtrl[evFree].firstTime=
-      runCtrl[evFree].lastTime=tsec ;
-      runCtrl[evFree].closeTime=tsec + 3600*24 ; //max time allowed
-      runCtrl[evFree].lastTime = 0 ;
+      runCtrl[evFree].procEvt = 0;
+      runCtrl[evFree].maxEvt = 999999999;       //max number events allowed
+      runCtrl[evFree].firstUsec = tusec;
+      runCtrl[evFree].firstTime = runCtrl[evFree].lastTime = tsec;
+      runCtrl[evFree].closeTime = tsec + 3600 * 24;     //max time allowed
+      runCtrl[evFree].lastTime = 0;
 
       runTail[evFree].nEventsOk =
-      runTail[evFree].nEventsRej =
-      runTail[evFree].nEventsBad =
-      runTail[evFree].PCtime0 =
-      runTail[evFree].PCtimeX = 0 ;
-   }
-   
-RUNFOUND:
-
-   needmem = sizeof(EVENT) + NPIX*nRoi[0]*2 + NTMARK*nRoi[0]*2; //
-
-   headmem = NBOARDS* sizeof(PEVNT_HEADER) ;
-
-   if ( gj.usdMem + needmem + headmem + gi_maxSize > g_maxMem) {
-        gj.maxMem = gj.usdMem + needmem + headmem + gi_maxSize ;
-        if (gi_memStat>0 ) {
-           gi_memStat = -99 ;
-           snprintf(str,MXSTR,"no memory left to keep event %6d sock %3d",evID,sk) ;
-           factOut(kError,882, str ) ;
-        } else {
-           snprintf(str,MXSTR,"no memory left to keep event %6d sock %3d",evID,sk) ;
-           factOut(kDebug,882, str ) ;
-        }
-        return -11 ;
-   }
-
-   mBuffer[i].FADhead = malloc( headmem ) ;
+         runTail[evFree].nEventsRej =
+         runTail[evFree].nEventsBad =
+         runTail[evFree].PCtime0 = runTail[evFree].PCtimeX = 0;
+   }
+
+ RUNFOUND:
+
+   needmem = sizeof (EVENT) + NPIX * nRoi[0] * 2 + NTMARK * nRoi[0] * 2;        //
+
+   headmem = NBOARDS * sizeof (PEVNT_HEADER);
+
+   if (gj.usdMem + needmem + headmem + gi_maxSize > g_maxMem) {
+      gj.maxMem = gj.usdMem + needmem + headmem + gi_maxSize;
+      if (gi_memStat > 0) {
+         gi_memStat = -99;
+         snprintf (str, MXSTR, "no memory left to keep event %6d sock %3d",
+                   evID, sk);
+         factOut (kError, 882, str);
+      } else {
+         snprintf (str, MXSTR, "no memory left to keep event %6d sock %3d",
+                   evID, sk);
+         factOut (kDebug, 882, str);
+      }
+      return -11;
+   }
+
+   mBuffer[i].FADhead = malloc (headmem);
    if (mBuffer[i].FADhead == NULL) {
-        snprintf(str,MXSTR,"malloc header failed for event %d",evID) ;
-        factOut(kError,882, str ) ;
+      snprintf (str, MXSTR, "malloc header failed for event %d", evID);
+      factOut (kError, 882, str);
       return -12;
    }
 
-   mBuffer[i].fEvent  = malloc( needmem ) ;
-   if (mBuffer[i].fEvent  == NULL) {
-        snprintf(str,MXSTR,"malloc data failed for event %d",evID) ;
-        factOut(kError,882, str ) ;
-      free(mBuffer[i].FADhead) ;
-      mBuffer[i].FADhead = NULL ;
+   mBuffer[i].fEvent = malloc (needmem);
+   if (mBuffer[i].fEvent == NULL) {
+      snprintf (str, MXSTR, "malloc data failed for event %d", evID);
+      factOut (kError, 882, str);
+      free (mBuffer[i].FADhead);
+      mBuffer[i].FADhead = NULL;
       return -22;
    }
 
-   mBuffer[i].buffer  = malloc( gi_maxSize ) ;
+   mBuffer[i].buffer = malloc (gi_maxSize);
    if (mBuffer[i].buffer == NULL) {
-        snprintf(str,MXSTR,"malloc buffer failed for event %d",evID) ;
-        factOut(kError,882, str ) ;
-      free(mBuffer[i].FADhead) ;
-      mBuffer[i].FADhead = NULL ;
-      free(mBuffer[i].fEvent) ;
-      mBuffer[i].fEvent = NULL ;
+      snprintf (str, MXSTR, "malloc buffer failed for event %d", evID);
+      factOut (kError, 882, str);
+      free (mBuffer[i].FADhead);
+      mBuffer[i].FADhead = NULL;
+      free (mBuffer[i].fEvent);
+      mBuffer[i].fEvent = NULL;
       return -32;
    }
-
-
-
    //flag all boards as unused
-   mBuffer[i].nBoard = 0 ;
-   for (k=0; k<NBOARDS; k++ ) {
+   mBuffer[i].nBoard = 0;
+   for (k = 0; k < NBOARDS; k++) {
       mBuffer[i].board[k] = -1;
    }
    //flag all pixels as unused
-   for (k=0; k<NPIX; k++ ) {
-      mBuffer[i].fEvent->StartPix[k] = -1 ;
+   for (k = 0; k < NPIX; k++) {
+      mBuffer[i].fEvent->StartPix[k] = -1;
    }
    //flag all TMark as unused
-   for (k=0; k<NTMARK; k++ ) {
-      mBuffer[i].fEvent->StartTM[k] = -1 ;
-   }
-
-   mBuffer[i].fEvent->NumBoards = 0 ;
-   mBuffer[i].fEvent->PCUsec = tusec ;
-   mBuffer[i].fEvent->PCTime = 
-   mBuffer[i].pcTime  = tsec ;
-   mBuffer[i].nRoi    = nRoi[0] ;
-   mBuffer[i].nRoiTM  = nRoi[8] ;
-   mBuffer[i].evNum   = evID ;
-   mBuffer[i].runNum  = runID ;
-   mBuffer[i].fadNum  = fadNum;
-   mBuffer[i].trgNum  = trgNum;
-   mBuffer[i].trgTyp  = trgTyp ;
-   mBuffer[i].evtLen  = needmem ;
+   for (k = 0; k < NTMARK; k++) {
+      mBuffer[i].fEvent->StartTM[k] = -1;
+   }
+
+   mBuffer[i].fEvent->NumBoards = 0;
+   mBuffer[i].fEvent->PCUsec = tusec;
+   mBuffer[i].fEvent->PCTime = mBuffer[i].pcTime = tsec;
+   mBuffer[i].nRoi = nRoi[0];
+   mBuffer[i].nRoiTM = nRoi[8];
+   mBuffer[i].evNum = evID;
+   mBuffer[i].runNum = runID;
+   mBuffer[i].fadNum = fadNum;
+   mBuffer[i].trgNum = trgNum;
+   mBuffer[i].trgTyp = trgTyp;
+   mBuffer[i].evtLen = needmem;
    mBuffer[i].Errors[0] =
-   mBuffer[i].Errors[1] =
-   mBuffer[i].Errors[2] =
-   mBuffer[i].Errors[3] = 0 ;
-
-   gj.usdMem += needmem + headmem + gi_maxSize ;
-   if (gj.usdMem > gj.maxMem ) gj.maxMem = gj.usdMem ; 
-
-   gj.bufTot++ ;
-   if (gj.bufTot > gj.maxEvt ) gj.maxEvt = gj.bufTot ;
-
-   gj.rateNew++ ;
+      mBuffer[i].Errors[1] = mBuffer[i].Errors[2] = mBuffer[i].Errors[3] = 0;
+
+   gj.usdMem += needmem + headmem + gi_maxSize;
+   if (gj.usdMem > gj.maxMem)
+      gj.maxMem = gj.usdMem;
+
+   gj.bufTot++;
+   if (gj.bufTot > gj.maxEvt)
+      gj.maxEvt = gj.bufTot;
+
+   gj.rateNew++;
 
    //register event in 'active list (reading)'
 
-   evtCtrl.evtBuf[  evtCtrl.lastPtr] = i ;
-   evtCtrl.evtStat[ evtCtrl.lastPtr] = 0 ;
-   evtCtrl.pcTime[  evtCtrl.lastPtr] = g_actTime ;
-   evtIdx[i] = evtCtrl.lastPtr ;
-
-
-   snprintf(str,MXSTR,"%5d %8d start new evt  %8d %8d sock %3d len %5d t %10d",
-      evID,runID,i,evtCtrl.lastPtr,sk,fadlen,mBuffer[i].pcTime);
-   factOut(kDebug,-11, str ) ;
-   evtCtrl.lastPtr++ ;
-   if (evtCtrl.lastPtr == MAX_EVT*MAX_RUN ) evtCtrl.lastPtr = 0;
-
-   gi.evtGet++ ;
-
-   return i ;
- 
+   evtCtrl.evtBuf[evtCtrl.lastPtr] = i;
+   evtCtrl.evtStat[evtCtrl.lastPtr] = 0;
+   evtCtrl.pcTime[evtCtrl.lastPtr] = g_actTime;
+   evtIdx[i] = evtCtrl.lastPtr;
+
+
+   snprintf (str, MXSTR,
+             "%5d %8d start new evt  %8d %8d sock %3d len %5d t %10d", evID,
+             runID, i, evtCtrl.lastPtr, sk, fadlen, mBuffer[i].pcTime);
+   factOut (kDebug, -11, str);
+   evtCtrl.lastPtr++;
+   if (evtCtrl.lastPtr == MAX_EVT * MAX_RUN)
+      evtCtrl.lastPtr = 0;
+
+   gi.evtGet++;
+
+   return i;
+
 } /*-----------------------------------------------------------------*/
 
